package nckd.jimin.jyyy.fi.business.plugin;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.logging.Log;
import kd.bos.logging.LogFactory;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.QueryServiceHelper;
import kd.fi.er.business.trip.exception.TripSyncLogParam;

import java.util.Map;

/**
 * 获取人员常驻工作地插件
 */
public class LocationCityPlugin {

    private static final Log logger = LogFactory.getLog(LocationCityPlugin.class);

    public Object getLocationCity(Map<String, Object> map, TripSyncLogParam tripSyncLogParam) {
        logger.info("商旅集成，字段映射插件执行：{} ", tripSyncLogParam.getTraceid());
        DynamicObject billInfo = (DynamicObject)map.get("bill");

        String billfield = (String)map.get("billfield");
        logger.info("billfield：{}  ", billfield);
        if(billInfo != null){
            // 传报销人
            return getLocationCity(billInfo.getDynamicObject("applier").getPkValue());
        }
        return null;
    }

    public Object getLocationCity(Object userId){
        // 申请人 -> HR人员 -> 常驻工作地 -> 工作地
        DynamicObject userInfo = QueryServiceHelper.queryOne("bos_user", "number", new QFilter("id,number", QCP.equals, userId).toArray());
        DynamicObject hrPerson = QueryServiceHelper.queryOne("hrpi_person", "id", new QFilter[]{
                new QFilter("number", QCP.equals, userInfo.getString("number")),
                new QFilter("iscurrentversion", QCP.equals, Boolean.TRUE)
        });

        if(hrPerson != null){
            DynamicObject baseLocation = QueryServiceHelper.queryOne("hrpi_baselocation", "location.city.id", new QFilter[]{
                    new QFilter("person", QCP.equals, hrPerson.getLong("id")),
                    new QFilter("iscurrentversion", QCP.equals, Boolean.TRUE)
            });

            if(baseLocation != null){
                return baseLocation.getLong("location.city.id");
            }

        }
        return null;
    }

}
